// $Id: ComInitializer.cpp,v 1.2 2001/06/27 03:45:37 cthuang Exp $
#include <tcl.h>
#include "ComInitializer.h"

struct ThreadSpecificData {
    DWORD flags;
    bool initialized;
};

static Tcl_ThreadDataKey threadDataKey;


void
ComInitializer::concurrencyModel (DWORD flags)
{
    ThreadSpecificData *tsdPtr = reinterpret_cast<ThreadSpecificData *>(
        Tcl_GetThreadData(&threadDataKey, sizeof(ThreadSpecificData)));

    tsdPtr->flags = flags;
}

DWORD
ComInitializer::concurrencyModel ()
{
    ThreadSpecificData *tsdPtr = reinterpret_cast<ThreadSpecificData *>(
        Tcl_GetThreadData(&threadDataKey, sizeof(ThreadSpecificData)));

    return tsdPtr->flags;
}

// This thread exit handler uninitializes COM.

static void
exitProc (ClientData)
{
    CoUninitialize();
}

void
ComInitializer::initialize ()
{
    ThreadSpecificData *tsdPtr = reinterpret_cast<ThreadSpecificData *>(
        Tcl_GetThreadData(&threadDataKey, sizeof(ThreadSpecificData)));

    if (!tsdPtr->initialized) {
#ifdef _WIN32_DCOM
        CoInitializeEx(NULL, tsdPtr->flags);
#else
        CoInitialize(NULL);
#endif

        Tcl_CreateThreadExitHandler(exitProc, 0);

        tsdPtr->initialized = true;
    }
}
