// $Id: nullCmd.cpp,v 1.7 2001/07/04 23:24:33 cthuang Exp $
#include <string.h>
#include "nullCmd.h"

// The string representation is the same for all objects of this type.

static char nullStringRep[] = "::tcom::NULL";

static void
nullUpdateString (Tcl_Obj *pObj)
{
    pObj->length = sizeof(nullStringRep) - 1;
    pObj->bytes = Tcl_Alloc(pObj->length + 1);
    strcpy(pObj->bytes, nullStringRep);
}

// Do not allow conversion from other types.

static int
nullSetFromAny (Tcl_Interp *interp, Tcl_Obj *)
{
    if (interp != NULL) {
        Tcl_AppendResult(interp, "cannot convert to ", nullType.name, NULL);
    }
    return TCL_ERROR;
}

Tcl_ObjType nullType = {
    nullStringRep,
    NULL,
    NULL,
    nullUpdateString,
    nullSetFromAny
};

// This Tcl command returns a null object which be used to pass a null pointer
// argument.

int
nullCmd (
    ClientData,
    Tcl_Interp *interp,
    int objc,
    Tcl_Obj *CONST objv[])
{
    if (objc != 1) {
	Tcl_WrongNumArgs(interp, 1, objv, NULL);
	return TCL_ERROR;
    }

    Tcl_Obj *pObj = Tcl_NewObj();
    Tcl_InvalidateStringRep(pObj);
    pObj->typePtr = &nullType;

    Tcl_SetObjResult(interp, pObj);
    return TCL_OK;
}
